## mingw-w64-sundials-7.3.0-1.src.tar.zst

=== CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Radu Serban, David J. Gardner, Cody J. Balos,
#                and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# Top level CMakeLists.txt for SUNDIALS (for cmake build system)
# ---------------------------------------------------------------

# ===============================================================
# Initial setup.
# ===============================================================

cmake_minimum_required(VERSION 3.18)

# Address DOWNLOAD_EXTRACT_TIMESTAMP warning with CMake 3.24+
if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.24")
  cmake_policy(SET CMP0135 NEW)
endif()

# Project SUNDIALS (initially only C supported) sets PROJECT_SOURCE_DIR and
# PROJECT_BINARY_DIR variables.
project(SUNDIALS C)

# Specify the location of additional CMAKE modules
set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake
    ${PROJECT_SOURCE_DIR}/cmake/macros ${PROJECT_SOURCE_DIR}/cmake/tpl)

# MACRO definitions
include(SundialsCMakeMacros)
include(CMakePrintHelpers)
include(CheckCSourceCompiles)
include(FindPackageHandleStandardArgs)

# Set some variables with info on the SUNDIALS project
set(PACKAGE_BUGREPORT "sundials-users@llnl.gov")
set(PACKAGE_NAME "SUNDIALS")
set(PACKAGE_STRING "SUNDIALS 7.3.0")
set(PACKAGE_TARNAME "sundials")

# Set SUNDIALS version numbers
sundials_git_version() # sets SUNDIALS_GIT_VERSION
message(STATUS "SUNDIALS_GIT_VERSION: ${SUNDIALS_GIT_VERSION}")

# (use "" for the version label if none is needed)
set(PACKAGE_VERSION_MAJOR "7")
set(PACKAGE_VERSION_MINOR "3")
set(PACKAGE_VERSION_PATCH "0")
set(PACKAGE_VERSION_LABEL "")

if(PACKAGE_VERSION_LABEL)
  set(PACKAGE_VERSION
      "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}-${PACKAGE_VERSION_LABEL}"
  )
else()
  set(PACKAGE_VERSION
      "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}"
  )
endif()

# Specify the VERSION and SOVERSION for shared libraries

set(arkodelib_VERSION "6.3.0")
set(arkodelib_SOVERSION "6")

set(cvodelib_VERSION "7.3.0")
set(cvodelib_SOVERSION "7")

set(cvodeslib_VERSION "7.3.0")
set(cvodeslib_SOVERSION "7")

set(idalib_VERSION "7.3.0")
set(idalib_SOVERSION "7")

set(idaslib_VERSION "6.3.0")
set(idaslib_SOVERSION "6")

set(kinsollib_VERSION "7.3.0")
set(kinsollib_SOVERSION "7")

set(cpodeslib_VERSION "0.0.0")
set(cpodeslib_SOVERSION "0")

set(nveclib_VERSION "7.3.0")
set(nveclib_SOVERSION "7")

set(sunmatrixlib_VERSION "5.3.0")
set(sunmatrixlib_SOVERSION "5")

set(sunlinsollib_VERSION "5.3.0")
set(sunlinsollib_SOVERSION "5")

set(sunnonlinsollib_VERSION "4.3.0")
set(sunnonlinsollib_SOVERSION "4")

set(sundialslib_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}"
)
set(sundialslib_SOVERSION "${PACKAGE_VERSION_MAJOR}")

# ===============================================================
# Initial Setup
# ===============================================================

# Prohibit in-source build
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source build prohibited.")
endif()

# Organize targets into folders when using an IDE
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Get correct build paths automatically, but expose LIBDIR and INCLUDEDIR as a
# regular cache variable so that a user can more easily see what they were set
# to by GNUInstallDirs.
include(GNUInstallDirs)
mark_as_advanced(CLEAR CMAKE_INSTALL_LIBDIR)
mark_as_advanced(CLEAR CMAKE_INSTALL_INCLUDEDIR)

# Suffixes to use for static and shared targets.
set(_STATIC_LIB_SUFFIX
    "_static"
    CACHE INTERNAL "" FORCE)
set(_SHARED_LIB_SUFFIX
    "_shared"
    CACHE INTERNAL "" FORCE)

# A list of all the alias targets created.
set(_SUNDIALS_ALIAS_TARGETS
    ""
    CACHE INTERNAL "" FORCE)

# We default to release builds
set(_DEFAULT_CMAKE_BUILD_TYPE RelWithDebInfo)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(
    STATUS
      "Building SUNDIALS in '${_DEFAULT_CMAKE_BUILD_TYPE}' mode as CMAKE_BUILD_TYPE was not specified."
  )
  set(CMAKE_BUILD_TYPE
      "${_DEFAULT_CMAKE_BUILD_TYPE}"
      CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
                                               "MinSizeRel" "RelWithDebInfo")
else()
  message(STATUS "Building SUNDIALS in '${CMAKE_BUILD_TYPE}' mode.")
endif()

# ===============================================================
# Build options to be processed first
# ===============================================================

include(SundialsDeprecated)
include(SundialsBuildOptionsPre)

# ===============================================================
# Options for external packages
# ===============================================================

include(SundialsTPLOptions)

# ===============================================================
# Options for examples
# ===============================================================

include(SundialsExampleOptions)

# ===============================================================
# Setup compilers
# ===============================================================

include(SundialsSetupCompilers)

# ===============================================================
# Setup third-party libraries
# ===============================================================

include(SundialsSetupTPLs)

# ===============================================================
# Build options to be processed last
# ===============================================================

include(SundialsBuildOptionsPost)

# ===============================================================
# At this point all the configuration options are set. Setup the
# sundials_config.h.
# ===============================================================

include(SundialsSetupConfig)

# ===============================================================
# Setup testing
# ===============================================================

include(SundialsSetupTesting)

# ===============================================================
# Add src and tests; optionally add examples and unit tests.
# ===============================================================

# Add selected packages and modules to the build
add_subdirectory(src)

# Add selected examples to the build
if(_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

# Add benchmarks to the build
if(BUILD_BENCHMARKS)
  include(SundialsSetupBenchmarks)
  add_subdirectory(benchmarks)
endif()

# Add unit tests to the build
if(SUNDIALS_TEST_ENABLE_UNIT_TESTS)
  add_subdirectory(test/unit_tests)
endif()

if(SUNDIALS_ENABLE_EXTERNAL_ADDONS)
  add_subdirectory(external)
endif()

# ===============================================================
# Install configuration header files and license file.
# ===============================================================

# install sundials_export header file
install(FILES "${PROJECT_BINARY_DIR}/include/sundials/sundials_export.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials")

# install configured header file
install(FILES "${PROJECT_BINARY_DIR}/include/sundials/sundials_config.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials")

# install shared Fortran 2003 modules
if(BUILD_FORTRAN_MODULE_INTERFACE)
  # While the .mod files get generated for static and shared libraries, they are
  # identical. So only install one set of the .mod files.
  if(BUILD_STATIC_LIBS)
    install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}_STATIC/
            DESTINATION ${Fortran_INSTALL_MODDIR})
  else()
    install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}_SHARED/
            DESTINATION ${Fortran_INSTALL_MODDIR})
  endif()
endif()

# install license and notice files
install(FILES "${PROJECT_SOURCE_DIR}/LICENSE"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials")
install(FILES "${PROJECT_SOURCE_DIR}/NOTICE"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sundials")

# create package version file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  SUNDIALSConfigVersion.cmake
  VERSION ${PACKAGE_VERSION}
  COMPATIBILITY AnyNewerVersion)

# install targets
install(
  EXPORT sundials-targets
  FILE SUNDIALSTargets.cmake
  NAMESPACE SUNDIALS::
  DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}")

# install SUNDIALSConfig.cmake
configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/SUNDIALSConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfig.cmake"
  INSTALL_DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSConfigVersion.cmake"
        DESTINATION "${SUNDIALS_INSTALL_CMAKEDIR}")

# Export targets so build directory can be used directly
export(
  EXPORT sundials-targets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/SUNDIALSTargets.cmake"
  NAMESPACE SUNDIALS::)

=== external/CMakeLists.txt ===
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------

# Steps to add an external addon to SUNDIALS:
#
# WARNING: external addons are not maintained by the SUNDIALS team and may come
# with their own license with different rules.
#
# 1. Clone/copy the addon into <sundials root>/external/ (the same directory as
#    this file you are reading).
# 2. Copy the sundials-addon-example block for your own external project.
# 3. When building SUNDIALS, set the CMake option SUNDIALS_ENABLE_EXTERNAL_ADDONS
#    to ON
# 4. Build SUNDIALS as usual.

include(FetchContent)

# COPY THE FetchContent BLOCK BELOW FOR YOUR OWN EXTERNAL ADDON COMMENT THESE
# LINES OUT TO DISABLE THE EXAMPLE ADDON
FetchContent_Declare(
  sundials-addon-example SOURCE_DIR
                         ${PROJECT_SOURCE_DIR}/external/sundials-addon-example)
FetchContent_MakeAvailable(sundials-addon-example)
# COPY THE BLOCK ABOVE FOR YOUR OWN EXTERNAL ADDON

=== benchmarks/advection_reaction_3D/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------

if(ENABLE_RAJA)
  add_subdirectory(raja)
endif()

if(ENABLE_KOKKOS AND BUILD_NVECTOR_KOKKOS)
  add_subdirectory(kokkos)
endif()

=== examples/arkode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/arkode level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(C_serial)
  if(BUILD_NVECTOR_MANYVECTOR)
    add_subdirectory(C_manyvector)
  endif()
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
  if(ENABLE_OPENMP_DEVICE
     AND OPENMP_FOUND
     AND OPENMP_SUPPORTS_DEVICE_OFFLOADING)
    add_subdirectory(C_openmpdev)
  endif()
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(C_parallel)
  endif()
  if(ENABLE_HYPRE AND HYPRE_FOUND)
    add_subdirectory(C_parhyp)
  endif()
  if(ENABLE_PETSC AND PETSC_FOUND)
    add_subdirectory(C_petsc)
  endif()
endif()

# C++ examples
if(EXAMPLES_ENABLE_CXX)
  add_subdirectory(CXX_serial)
  if(BUILD_NVECTOR_MANYVECTOR)
    add_subdirectory(CXX_manyvector)
  endif()
  if(ENABLE_MPI AND MPI_CXX_FOUND)
    add_subdirectory(CXX_parallel)
  endif()
  if(ENABLE_MPI
     AND MPI_CXX_FOUND
     AND ENABLE_HYPRE
     AND HYPRE_FOUND)
    add_subdirectory(CXX_parhyp)
  endif()
  if(MPI_CXX_FOUND AND ENABLE_SUPERLUDIST)
    add_subdirectory(CXX_superludist)
  endif()
  if(ENABLE_XBRAID)
    add_subdirectory(CXX_xbraid)
  endif()
endif()

# F2003 examples
if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
  add_subdirectory(F2003_custom)
  if(ENABLE_MPI AND MPI_Fortran_FOUND)
    add_subdirectory(F2003_parallel)
  endif()
endif()

=== examples/cvodes/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/cvodes level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(serial)
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(parallel)
  endif()
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
endif()

if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
endif()

=== examples/kinsol/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner and Slaven Peles @ LLNL
#                Shelby Lockhart @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/kinsol level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(serial)
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    # the only example here need special handling from testrunner (not yet
    # implemented)
    add_subdirectory(C_openmp)
  endif()
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(parallel)
  endif()
endif()

# C++ examples
if(EXAMPLES_ENABLE_CXX)
  if(ENABLE_MPI AND MPI_CXX_FOUND)
    add_subdirectory(CXX_parallel)
  endif()
  if(ENABLE_MPI
     AND MPI_CXX_FOUND
     AND ENABLE_HYPRE
     AND HYPRE_FOUND)
    add_subdirectory(CXX_parhyp)
  endif()
endif()

# CUDA examples
if(EXAMPLES_ENABLE_CUDA)
  if(ENABLE_MPI AND MPI_CXX_FOUND)
    add_subdirectory(CUDA_mpi)
  endif()
endif()

# Fortran examples
if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
  if(ENABLE_MPI)
    add_subdirectory(F2003_parallel)
  endif()
endif()

=== src/arkode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU, Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the ARKODE library
# ---------------------------------------------------------------

install(CODE "MESSAGE(\"\nInstall ARKODE\n\")")

# Add variable arkode_SOURCES with the sources for the ARKODE library
set(arkode_SOURCES
    arkode_adapt.c
    arkode_arkstep_io.c
    arkode_arkstep_nls.c
    arkode_arkstep.c
    arkode_bandpre.c
    arkode_bbdpre.c
    arkode_butcher_dirk.c
    arkode_butcher_erk.c
    arkode_butcher.c
    arkode_erkstep_io.c
    arkode_erkstep.c
    arkode_forcingstep.c
    arkode_interp.c
    arkode_io.c
    arkode_ls.c
    arkode_lsrkstep_io.c
    arkode_lsrkstep.c
    arkode_mri_tables.c
    arkode_mristep_controller.c
    arkode_mristep_io.c
    arkode_mristep_nls.c
    arkode_mristep.c
    arkode_relaxation.c
    arkode_root.c
    arkode_splittingstep_coefficients.c
    arkode_splittingstep.c
    arkode_sprkstep_io.c
    arkode_sprkstep.c
    arkode_sprk.c
    arkode_sunstepper.c
    arkode_user_controller.c
    arkode.c)

# Add variable arkode_HEADERS with the exported ARKODE header files
set(arkode_HEADERS
    arkode.h
    arkode_arkstep.h
    arkode_bandpre.h
    arkode_bbdpre.h
    arkode_butcher.h
    arkode_butcher_dirk.h
    arkode_butcher_erk.h
    arkode_erkstep.h
    arkode_forcingstep.h
    arkode_ls.h
    arkode_lsrkstep.h
    arkode_mristep.h
    arkode_splittingstep.h
    arkode_sprk.h
    arkode_sprkstep.h)

# Add prefix with complete path to the ARKODE header files
add_prefix(${SUNDIALS_SOURCE_DIR}/include/arkode/ arkode_HEADERS)

# Create the sundials_arkode library
sundials_add_library(
  sundials_arkode
  SOURCES ${arkode_SOURCES}
  HEADERS ${arkode_HEADERS}
  INCLUDE_SUBDIR arkode
  LINK_LIBRARIES PUBLIC sundials_core
  OBJECT_LIBRARIES
    sundials_sunmemsys_obj
    sundials_nvecserial_obj
    sundials_nvecmanyvector_obj
    sundials_sunadaptcontrollersoderlind_obj
    sundials_sunadaptcontrollerimexgus_obj
    sundials_sunadaptcontrollermrihtol_obj
    sundials_sunmatrixband_obj
    sundials_sunmatrixdense_obj
    sundials_sunmatrixsparse_obj
    sundials_sunlinsolband_obj
    sundials_sunlinsoldense_obj
    sundials_sunlinsolspbcgs_obj
    sundials_sunlinsolspfgmr_obj
    sundials_sunlinsolspgmr_obj
    sundials_sunlinsolsptfqmr_obj
    sundials_sunlinsolpcg_obj
    sundials_sunnonlinsolnewton_obj
    sundials_sunnonlinsolfixedpoint_obj
    sundials_adjointcheckpointscheme_fixed_obj
  OUTPUT_NAME sundials_arkode
  VERSION ${arkodelib_VERSION}
  SOVERSION ${arkodelib_SOVERSION})

# Finished ARKODE
message(STATUS "Added ARKODE module")

# Add F2003 module if the interface is enabled
if(BUILD_FORTRAN_MODULE_INTERFACE)
  add_subdirectory("fmod_int${SUNDIALS_INDEX_SIZE}")
endif()

# Add ARKODE XBraid interface
if(ENABLE_XBRAID)
  add_subdirectory(xbraid)
endif()

=== src/kinsol/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU
#                Radu Serban, Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the KINSOL library
# ---------------------------------------------------------------

install(CODE "MESSAGE(\"\nInstall KINSOL\n\")")

# Add variable kinsol_SOURCES with the sources for the KINSOL library
set(kinsol_SOURCES kinsol.c kinsol_bbdpre.c kinsol_io.c kinsol_ls.c)

# Add variable kinsol_HEADERS with the exported KINSOL header files
set(kinsol_HEADERS kinsol.h kinsol_bbdpre.h kinsol_ls.h)

# Add prefix with complete path to the KINSOL header files
add_prefix(${SUNDIALS_SOURCE_DIR}/include/kinsol/ kinsol_HEADERS)

# Create the library
sundials_add_library(
  sundials_kinsol
  SOURCES ${kinsol_SOURCES}
  HEADERS ${kinsol_HEADERS}
  INCLUDE_SUBDIR kinsol
  LINK_LIBRARIES PUBLIC sundials_core
  OBJECT_LIBRARIES
    sundials_sunmemsys_obj
    sundials_nvecserial_obj
    sundials_sunmatrixband_obj
    sundials_sunmatrixdense_obj
    sundials_sunmatrixsparse_obj
    sundials_sunlinsolband_obj
    sundials_sunlinsoldense_obj
    sundials_sunlinsolspbcgs_obj
    sundials_sunlinsolspfgmr_obj
    sundials_sunlinsolspgmr_obj
    sundials_sunlinsolsptfqmr_obj
    sundials_sunlinsolpcg_obj
  OUTPUT_NAME sundials_kinsol
  VERSION ${kinsollib_VERSION}
  SOVERSION ${kinsollib_SOVERSION})

# Finished KINSOL
message(STATUS "Added KINSOL module")

# Add F2003 module if the interface is enabled
if(BUILD_FORTRAN_MODULE_INTERFACE)
  add_subdirectory("fmod_int${SUNDIALS_INDEX_SIZE}")
endif()

=== src/nvector/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------
# vector level CMakeLists.txt for SUNDIALS
# ------------------------------------------------------------------------------

# required modules
add_subdirectory(serial)

if(BUILD_NVECTOR_MANYVECTOR OR BUILD_NVECTOR_MPIMANYVECTOR)
  add_subdirectory(manyvector)
endif()

if(BUILD_NVECTOR_PARALLEL)
  add_subdirectory(parallel)
endif()

if(BUILD_NVECTOR_MPIPLUSX)
  add_subdirectory(mpiplusx)
endif()

if(BUILD_NVECTOR_PARHYP)
  add_subdirectory(parhyp)
endif()

if(BUILD_NVECTOR_OPENMP)
  add_subdirectory(openmp)
endif()

if(BUILD_NVECTOR_OPENMPDEV)
  add_subdirectory(openmpdev)
endif()

if(BUILD_NVECTOR_PTHREADS)
  add_subdirectory(pthreads)
endif()

if(BUILD_NVECTOR_PETSC)
  add_subdirectory(petsc)
endif()

if(BUILD_NVECTOR_CUDA)
  add_subdirectory(cuda)
endif()

if(BUILD_NVECTOR_HIP)
  add_subdirectory(hip)
endif()

if(BUILD_NVECTOR_SYCL)
  add_subdirectory(sycl)
endif()

if(BUILD_NVECTOR_RAJA)
  add_subdirectory(raja)
endif()

if(BUILD_NVECTOR_TRILINOS)
  add_subdirectory(trilinos)
endif()

if(BUILD_NVECTOR_KOKKOS)
  install(CODE "MESSAGE(\"\nInstall NVECTOR_KOKKOS\n\")")
  message(STATUS "Added BUILD_NVECTOR_KOKKOS module")
  add_library(sundials_nveckokkos INTERFACE)
  target_link_libraries(sundials_nveckokkos INTERFACE sundials_core)
  if(ENABLE_HIP)
    target_link_libraries(sundials_nveckokkos INTERFACE Kokkos::kokkos
                                                        hip::device)
  else()
    target_link_libraries(sundials_nveckokkos INTERFACE Kokkos::kokkos)
  endif()
  target_include_directories(
    sundials_nveckokkos
    INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
              $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
              $<BUILD_INTERFACE:${SUNDIALS_SOURCE_DIR}/src/sundials>
              $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
  install(FILES ${PROJECT_SOURCE_DIR}/include/nvector/nvector_kokkos.hpp
          DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/nvector")
  set(_SUNDIALS_INSTALLED_COMPONENTS
      "nveckokkos;${_SUNDIALS_INSTALLED_COMPONENTS}"
      CACHE INTERNAL "" FORCE)
endif()

=== src/sunadaptcontroller/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------
# adaptivity controller level CMakeLists.txt for SUNDIALS
# ------------------------------------------------------------------------------

# required native adaptivity controllers
add_subdirectory(imexgus)
add_subdirectory(soderlind)
add_subdirectory(mrihtol)

=== test/unit_tests/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# unit_tests level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

message("Adding units tests")

# Disable some warnings for tests
if(ENABLE_ALL_WARNINGS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-parameter")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
endif()

add_subdirectory(sundials)

if(BUILD_ARKODE)
  add_subdirectory(arkode)
endif()

if(BUILD_CVODE)
  add_subdirectory(cvode)
endif()

if(BUILD_CVODES)
  add_subdirectory(cvodes)
endif()

if(BUILD_IDA)
  add_subdirectory(ida)
endif()

if(BUILD_IDAS)
  add_subdirectory(idas)
endif()

if(BUILD_KINSOL)
  add_subdirectory(kinsol)
endif()

add_subdirectory(nvector)

add_subdirectory(sunmatrix)

add_subdirectory(sunlinsol)

add_subdirectory(sunnonlinsol)

add_subdirectory(sunadjointcheckpointscheme)

if(CXX_FOUND)
  add_subdirectory(logging)
  add_subdirectory(sunmemory)
  if(SUNDIALS_BUILD_WITH_PROFILING)
    add_subdirectory(profiling)
  endif()
endif()

=== benchmarks/advection_reaction_3D/kokkos/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s):  Daniel R. Reynolds @ SMU
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------

# Add the build targets for each backend
if(BUILD_ARKODE
   AND BUILD_CVODE
   AND BUILD_IDA)
  foreach(backend ${KOKKOS_EXAMPLES_BACKENDS})

    # set benchmark target name
    set(benchmark_target "advection_reaction_3D_kokkos.${backend}")

    # benchmark source files
    sundials_add_executable(
      ${benchmark_target}
      advection_reaction_3D.cpp
      arkode_driver.cpp
      cvode_driver.cpp
      ida_driver.cpp
      rhs3D.hpp
      ParallelGrid.hpp
      check_retval.h)

    # which backend to use
    target_compile_definitions(${benchmark_target} PRIVATE USE_${backend})

    # directories to include
    target_include_directories(
      ${benchmark_target} PRIVATE ${PROJECT_SOURCE_DIR}/utilities
                                  ${MPI_CXX_INCLUDE_DIRS})

    # libraries to link against
    target_link_libraries(
      ${benchmark_target}
      PRIVATE sundials_arkode
              sundials_cvode
              sundials_ida
              sundials_nvecmpiplusx
              sundials_nveckokkos
              ${MPI_CXX_LIBRARIES}
              ${EXE_EXTRA_LINK_LIBS})

    install(
      TARGETS ${benchmark_target}
      DESTINATION "${BENCHMARKS_INSTALL_PATH}/advection_reaction_3D/kokkos")

    install(
      FILES README.md ../scripts/compare_error.py ../scripts/compute_error.py
            ../scripts/pickle_solution_output.py
      DESTINATION "${BENCHMARKS_INSTALL_PATH}/advection_reaction_3D/kokkos")

  endforeach()
endif()

=== PKGBUILD ===
# Maintainer: Gene Harvey <gharveymn@gmail.com>

_enable_mpi=no

if [[ ${CARCH} != x86_64 ]]; then
  # There are currently no msmpi libraries for Windows on ARM.
  # See: https://github.com/microsoft/Microsoft-MPI/issues/66
  # So even if it were enabled for other targets above, don't build the features
  # that require msmpi for ARM targets.
  _enable_mpi=no
fi

_realname=sundials
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=7.3.0
pkgrel=1
pkgdesc="SUite of Nonlinear and DIfferential/ALgebraic equation Solvers (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://computing.llnl.gov/projects/sundials"
msys2_repository_url="https://github.com/LLNL/sundials"
msys2_references=(
  'archlinux: sundials'
)
license=('spdx:BSD-3-Clause')
replaces=("${MINGW_PACKAGE_PREFIX}-cvode")
provides=("${MINGW_PACKAGE_PREFIX}-cvode")
conflicts=("${MINGW_PACKAGE_PREFIX}-cvode")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-suitesparse"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         $([[ "$_enable_mpi" == "yes" ]] && echo \
           "${MINGW_PACKAGE_PREFIX}-petsc" \
           "${MINGW_PACKAGE_PREFIX}-superlu_dist"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-fc")
             $([[ "$_enable_mpi" == "yes" ]] && echo "${MINGW_PACKAGE_PREFIX}-msmpi"))
optdepends=("${MINGW_PACKAGE_PREFIX}-python: for running examples")
source=(https://github.com/LLNL/sundials/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz
        '0001-fix-building-openmp-example-with-flang.patch'
        '0008-sundials-petsc-pkg-config-module.patch')
sha256sums=('fd970a9023f8ea37b81c5065c067bf1726f656b39f5907b48169a6f98d306ba7'
            '785b7a824702fcc3267cec5d3f9c418dee2940efc9513516c642fd3129e36eb5'
            '46f341d50e97960fd93ee516e7ade99ca5ac87db7d5d077ae09d26da3e4f7355')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${_realname}-${pkgver}"

  apply_patch_with_msg \
    0001-fix-building-openmp-example-with-flang.patch \
    0008-sundials-petsc-pkg-config-module.patch
}

_petsc_arch=dmo

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ "$_enable_mpi" != "yes" ]]; then
    _extra_config+=("-DENABLE_MPI=OFF"
                    "-DENABLE_PETSC=OFF"
                    "-DENABLE_SUPERLUDIST=OFF")
  else
    _extra_config+=("-DBUILD_NVECTOR_MANYVECTOR=ON"
                    "-DBUILD_NVECTOR_MPIMANYVECTOR=ON"
                    "-DBUILD_NVECTOR_MPIPLUSX=ON"
                    "-DBUILD_NVECTOR_PARALLEL=ON"
                    "-DENABLE_MPI=ON"
                    "-DENABLE_PETSC=ON"
                    "-DENABLE_SUPERLUDIST=ON"
                    "-DPETSC_PKG_CONFIG_MODULE=petsc-${_petsc_arch}"
                    "-DSUNDIALS_LOGGING_ENABLE_MPI=OFF"
                    "-DSUPERLUDIST_INCLUDE_DIRS=${MINGW_PREFIX}/include/superlu_dist"
                    "-DSUPERLUDIST_CONFIG_PATH=${MINGW_PREFIX}/include/superlu_dist/superlu_dist_config.h"
                    "-DSUPERLUDIST_INDEX_SIZE=32"
                    "-DSUPERLUDIST_OpenMP=ON"
                    "-DMPI_C_COMPILER=${MINGW_PREFIX}/bin/mpicc.exe"
                    "-DMPI_CXX_COMPILER=${MINGW_PREFIX}/bin/mpicxx.exe")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _extra_config+=("-DBUILD_FORTRAN_MODULE_INTERFACE=OFF"
                    "-DEXAMPLES_ENABLE_F2003=OFF")
  else
    _extra_config+=("-DBUILD_FORTRAN_MODULE_INTERFACE=ON"
                    "-DEXAMPLES_ENABLE_F2003=ON"
                    "-DFortran_INSTALL_MODDIR=include/sundials/fortran")
  fi

  I_MPI_ROOT="" \
  CFLAGS+=" -Wno-return-type -Wno-deprecated-declarations" \
  LDFLAGS+=" -Wl,--export-all-symbols" \
  MSYS2_ARG_CONV_EXCL="CMAKE_INSTALL_PREFIX=;EXAMPLES_INSTALL_PATH=" \
  ${MINGW_PREFIX}/bin/cmake \
    -D BUILD_ARKODE=ON \
    -D BUILD_CVODE=ON \
    -D BUILD_CVODES=ON \
    -D BUILD_IDA=ON \
    -D BUILD_IDAS=ON \
    -D BUILD_KINSOL=ON \
    -D BUILD_NVECTOR_OPENMP=ON \
    -D BUILD_NVECTOR_PTHREADS=ON \
    -D BUILD_SHARED_LIBS=ON \
    -D BUILD_STATIC_LIBS=ON \
    -D BUILD_SUNLINSOL_KLU=ON \
    -D BUILD_SUNLINSOL_LAPACKBAND=ON \
    -D BUILD_SUNLINSOL_LAPACKDENSE=ON \
    -D BUILD_TESTING=OFF \
    "${_extra_config[@]}" \
    -D CMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -D CMAKE_RUNTIME_OUTPUT_DIRECTORY="${srcdir}/build-${MSYSTEM}"/build-output/bin \
    -D CMAKE_SYSTEM_IGNORE_PATH=/usr/lib \
    -D CMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -D ENABLE_CUDA=OFF \
    -D ENABLE_HIP=OFF \
    -D ENABLE_HYPRE=OFF \
    -D ENABLE_KLU=ON \
    -D ENABLE_LAPACK=ON \
    -D ENABLE_MAGMA=OFF \
    -D ENABLE_OPENMP=ON \
    -D ENABLE_OPENMP_DEVICE=OFF \
    -D ENABLE_PTHREAD=ON \
    -D ENABLE_RAJA=OFF \
    -D ENABLE_SUPERLUMT=OFF \
    -D ENABLE_SYCL=OFF \
    -D ENABLE_TRILINOS=OFF \
    -D ENABLE_XBRAID=OFF \
    -D EXAMPLES_ENABLE_C=ON \
    -D EXAMPLES_ENABLE_CXX=ON \
    -D EXAMPLES_INSTALL=ON \
    -D EXAMPLES_INSTALL_PATH=${MINGW_PREFIX}/share/sundials/examples \
    -D LAPACK_LIBRARIES=${MINGW_PREFIX}/lib/libopenblas.dll.a \
    -D SUNDIALS_BUILD_WITH_PROFILING=OFF \
    -D SUNDIALS_BUILD_WITH_MONITORING=ON \
    -D SUNDIALS_INDEX_SIZE=64 \
    -D SUNDIALS_PRECISION=DOUBLE \
    -D SUNDIALS_LAPACK_CASE=LOWER \
    -D SUNDIALS_LAPACK_UNDERSCORES=ONE \
    -B build-${MSYSTEM} \
    -S ${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
}

check() {
  # Skip tests requiring MPI.
  ${MINGW_PREFIX}/bin/cmake -Bbuild-${MSYSTEM} -S${_realname}-${pkgver} -DBUILD_TESTING=ON
  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
  ${MINGW_PREFIX}/bin/ctest \
    --exclude-regex "mpi|parallel|petsc|superludist|slunrloc" \
    --test-dir build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" \
  ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Install the LICENSE and NOTICE files to the system licenses directory.
  install -D --mode=644  \
    --target-directory="${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname} \
    "${srcdir}/${_realname}-${pkgver}"/{LICENSE,NOTICE}

  ## Patch various files to be relocatable.

  # Patch the CMake export modules.
  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/sundials/SUNDIALSTargets*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i "${_f}"
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i "${_f}"
  done

  # Patch the CMake config module.
  sed -e "s|${PREFIX_WIN}|\$\{PACKAGE_PREFIX_DIR\}|g" \
      -i "${pkgdir}${MINGW_PREFIX}"/lib/cmake/sundials/SUNDIALSConfig.cmake

  sed -e "s|${MINGW_PREFIX}|\$\{PACKAGE_PREFIX_DIR\}|g" \
      -i "${pkgdir}${MINGW_PREFIX}"/lib/cmake/sundials/SUNDIALSConfig.cmake

  # Patch the CMakeLists.txt files in the examples.
  shopt -s globstar
  for _f in "${pkgdir}${MINGW_PREFIX}"/share/sundials/examples/**/CMakeLists.txt; do
    _fdir=$(dirname "${_f}")
    _relative_root=$(realpath --relative-to="${_fdir}" "${pkgdir}${MINGW_PREFIX}")
    sed -e "s|${PREFIX_WIN}|\$\{CMAKE_CURRENT_LIST_DIR\}/${_relative_root}|g"   -i "${_f}"
    sed -e "s|${MINGW_PREFIX}|\$\{CMAKE_CURRENT_LIST_DIR\}/${_relative_root}|g" -i "${_f}"
  done
}
